<?xml version="1.0"?>

<!--Copyright (c) 2019, The Linux Foundation. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above
      copyright notice, this list of conditions and the following
      disclaimer in the documentation and/or other materials provided
      with the distribution.
    * Neither the name of The Linux Foundation nor the names of its
      contributors may be used to endorse or promote products derived
      from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.-->

<launch>
  <param name="use_sim_time" value="false" />

  <arg name="urdf_file" default="$(find xacro)/xacro --inorder '$(find kobuki_description)/urdf/kobuki_standalone.urdf.xacro'"/>
  <param name="robot_description" command="$(arg urdf_file)"/>

  <!--node name="map_server" pkg="map_server" type="map_server" args="/data/pathplan/map/mymap.yaml"/-->

  <!--this node is for hls_lfcd lidar-->
  <node pkg="hls_lfcd_lds_driver" type="hlds_laser_publisher" name="turtlebot3_lds" output="screen">
    <param name="port" value="/dev/lidar"/>
    <param name="frame_id" value="laser"/>
  </node>
 
  <!--this node for rplidar A1/A2/A3, A1/A2: serial baudrate is 115200, A3: serial baudeate is 256000-->
  <!--node name="rplidarNode" pkg="rplidar_ros"  type="rplidarNode" output="screen">
     <param name="serial_port" type="string" value="/dev/lidar"/>
     <param name="serial_baudrate"     type="int"    value="115200"/>
     <param name="frame_id"            type="string" value="laser"/>
     <param name="inverted"            type="bool"   value="false"/>
     <param name="angle_compensate"    type="bool"   value="true"/>
  </node-->

  <!-- this node for ydlidar-->
  <!--node name="ydlidar_node"  pkg="ydlidar_ros"  type="ydlidar_node" output="screen">
     <remap from="scan"             to="/scan" />
     <param name="port"             type="string" value="/dev/lidar"/>
     <param name="baudrate"         type="int" value="230400"/>
     <param name="frame_id"         type="string" value="laser"/>
     <param name="angle_fixed"      type="bool"   value="true"/>
     <param name="low_exposure"     type="bool"   value="false"/>
     <param name="heartbeat"        type="bool"   value="false"/>
     <param name="resolution_fixed" type="bool"   value="true"/>
     <param name="angle_min"        type="double" value="-135" />
     <param name="angle_max"        type="double" value="135" />
     <param name="range_min"        type="double" value="0.08" />
     <param name="range_max"        type="double" value="16.0" />
     <param name="ignore_array"     type="string" value="" />
     <param name="samp_rate"        type="int"    value="4"/>
     <param name="frequency"        type="double" value="7"/>
  </node-->

  <node pkg="move_base" type="move_base" respawn="false" name="move_base" output="screen" clear_params="true">
    <param name="controller_frequency" value="10.0"/>
    <param name="controller_patiente" value="15.0"/>
    <remap from="/cmd_vel" to="/mobile_base/commands/velocity"/>
    <!--remap from="/wheel_odom" to="odom"/-->
    <rosparam file="/data/pathplan/nav_config/costmap_common_params.yaml" command="load" ns="global_costmap" />
    <rosparam file="/data/pathplan/nav_config/costmap_common_params.yaml" command="load" ns="local_costmap" />
    <rosparam file="/data/pathplan/nav_config/local_costmap_params.yaml" command="load" />
    <rosparam file="/data/pathplan/nav_config/global_costmap_params.yaml" command="load" />
    <rosparam file="/data/pathplan/nav_config/base_local_planner_params.yaml" command="load" />
  </node>

  <include file="/data/pathplan/launch/gmapping.launch">
  </include>  

    <!-- static_transform_publisher x y z yaw pitch roll frame_id child_frame_id period_in_ms -->  
  <node pkg="tf" type="static_transform_publisher" name="base_footprint_to_base_link" args="0 0 0.5 0 0 0 base_footprint base_link 50" />
  <node pkg="tf" type="static_transform_publisher" name="base_link_to_laser" args="0 0 0.5 0 0 0 base_link laser 50" />
</launch>
